;,-----------------------------------------------------------------,
;|  Domaci zadatak br.1 iz predmeta Mikroprocesorski sistemi:      |
;|                                                                 |
;|   Napisati program  na asembleru mikroprocesora i8086 koji      |
;|   pronalazi  broj pojavljivanja  nekog stringa  u  zadatom      |
;|   ulaznom fajlu . String se moze uneti sa tastature ili se      |
;|   moze nalaziti  u fajlu  cije se ime zadaje sa tastature.      |
;|                                                                 |
;|  PoPS v1.16 	                                                   |
;|                                                                 |
;|   Autori:                                                       |
;|    Ivana Vujovic   ile@galeb.etf.bg.ac.yu                       |
;|    Milos Kovacevic pirate@bitsyu.net, http://www.mpirate.net	   |
;|		                                                   |
;\_________________________________________________________________'

 extrn	SEEK:near			; eksterna procedura za brojanje ponavljanja stringa u fajlu
 extrn 	PisiBP:near			; za ispis decimalne vrednosti registar BP
 extrn  GrOtv:near,GrCit:near		; za prijavljivanje greske pri radu sa fajlovima
 KOD 	segment para public 'code'
  assume CS:KOD, DS:KOD, ES:KOD		; sve se nalazi u jednom segmentu
  public casesens,string,stringduz	; javne promenljive koje se koriste u spoljasnjim procedurama
	
;-----------------------------------------------------------------
; Podaci	                                                  
;_________________________________________________________________

 uvod		db	"----------------------------------------------------------------",13,10
 		db	"PoPS v1.16s - 25.01.2001.",13,10
 		db	" Program za brojanje Pojavljivanja Stringa u datoteci",13,10
 		db	" Autori:",13,10 
 		db	"  Ivana Vujovic   ile@galeb.etf.bg.ac.yu",13,10
 		db	"  Milos Kovacevic pirate@bitsyu.net,     http://www.mpirate.net",13,10
 		db	"----------------------------------------------------------------",13,10,"$"
 stringupit	db	13,10,13,10," - String za pretrazivanje se"
 		db	13,10,"    -  unosi preko (T)astature [podrazumevano]"
 		db	13,10,"    -  nalazi u (D)atoteci"
 		db	13,10," [T/d/<esc>] >$"
 unosstringa	db	13,10," - Unesi string za pretrazivanje (do 254 znaka)"
 		db	13,10," [PoPS] >$"
 unosstrfajla   db	13,10," - Unesi ime datoteke (do 31 znak) u kojoj se nalazi string za pretrazivanje"
 		db	13,10," [PoPS] >$"
 strfajlprazan  db      13,10,7,"!!! [GRESKA]: Datoteka je prazna !!!$"
 prviredprazan  db 	13,10,7,"!!! [GRESKA]: Prvi red datoteke je prazan !!!$"
 unosfajla	db	13,10," - Unesi ime datoteke (do 31 znak) koja se pretrazuje"
 		db	13,10," [PoPS] >$"
 caseupit	db	13,10," - Mala i velika slova se"
 		db	13,10,"    - (N)e razlikuju [podrazumevano]"
 		db	13,10,"    - (R)azlikuju"
 		db	13,10," [N/r] >$"
 brojpojav	db	13,10,13,10,"*** Broj pojavljivanja stringa je: $"
  
 casesens	db	?			; da li je case sensitive
 fajlmaxduz	db	64			; maximalan broj znakova imena fajla
 fajlduz	db	?			; broj znakova imena fajla
 imefajla	db	64 dup (?)		; puno ime fajla (moze da sadrzi i direktorijum i disk)
  
 stringmaxduz	db	255			; maksimalna duzina stringa
 stringduz	db	?			; stvarna duzina stringa
 string		db	255 dup (?)		; string

;-----------------------------------------------------------------
; Kod	                                           
;_________________________________________________________________
	even			; pocni od parne adrese
 START:	mov AX,CS		; pocetak programa
	mov DS,AX		; posto su i podaci u kod segmentu cs se kopira u ds
	mov ES,AX		; i u es

	mov DX,offset uvod	; ispis uvodne poruke: ds:dx ukazuje na poruku
	mov AH,9		; funkcija broj 9
	int 21h			; dos interapta 21h sluzi za ispis stringa

 upit:	mov DX,offset stringupit; ispis poruke za upit o nacinu 
	mov AH,9		; unosenja stringa za pretrazivanje
	int 21h			; 
	
     	mov AH,1		; funkcija broj 1
     	int 21h			; dos interapta 21h sluzi za unos 1 karaktera u AL
     	
     	cmp AL,"t"		; uneseni karakter se poredvi sa svim validnim vrednostima:
     	je  unosT		; T = unos stringa sa tastature
     	cmp AL,"T"		; t =
     	je  unosT		; unos stringa sa tastature
     	cmp AL,13		; <enter> =
     	je  unosT		; podrazumevano: unos stringa sa tastature
     	cmp AL,"d"		; D =
     	je  unosSF		; unos stringa preko fajla
     	cmp AL,"D"		; d =
     	je  unosSF		; unos stringa preko fajla
	cmp AL,27		; <esc> = izlaz
     	jne upit		; ako je pritisnuto nedozvoljeno dugme vraca se na upit
     	jmp KRAJ
;-----------------------------------------------------------------
; Unos stringa za pretrazivanje preko tastature
; VAZNO: Duzina stringa je ogranicena na 254 znaka + <CR> (<ENTER>)
;_________________________________________________________________
     	
 unosT:	mov DX,offset unosstringa	; ispis poruke
	mov AH,9			; "Unesi string"
	int 21h      	     	
	
	mov DX,offset stringmaxduz	; unos stringa
	mov AH,0Ah			; Funkcija 0Ah INT21h sluzi za ucitavanje stringa
	int 21h				; preko tastature u bafer na koji ukazuje DS:DX
					; pri cemu je 1. bajt bafera ulazni podatak: maksimalan broj znakova
	mov AL,stringduz		; a 2. bajt je broj stvarno procitanih znakova
	cmp AL,0			; koji se poredi sa nulom
	je  upit			; i ako nije nista uneseno ponavlja upit
	jmp unosF			; a ako jeste ide se dalje na ucitavaje fajla za pretragu
;-----------------------------------------------------------------
; Unos stringa za pretrazivanje preko fajla
;_________________________________________________________________
     	
 unosSF:mov DX,offset unosstrfajla	; ispis poruke
	mov AH,9			; "unesi fajl sa stringom"
	int 21h
	
	mov DX,offset fajlmaxduz
	mov AH,0Ah		; ucitavanje imena fajla sa stringom
	int 21h			; ime fajla je ograniceno na 31 znak
     
     	xor BH,BH		; BH=0
     	mov BL,fajlduz		; BX=br.procitanih karaktera < 32
     	cmp BL,0
     	je  upit		; ako nije nista uneseno ponavlja se upit
	mov byte ptr imefajla[BX],0	; poslednji karakter imena fajla mora biti 0
     	
     	mov DX,offset imefajla	; DS:DX ukazuje na ime fajla sa nulom na kraju
     	mov AX,3D00h		; funkcija 3Dh je za OTVARANJE fajla 
     	int 21h			; (AL=00 = read only)
     	jnc StrFOK		; nije bilo greske pri otvaranju StringFile OK
     	call grotv		; greska pri otvaranju - obavestava se korisnik
     	jmp unosSF		; i trazi novi fajl
 StrFOK:mov BX,AX		; file handle je po otvaranju u AX,a nama treba u BX
 ;-----------------------------------------------------------------
 ; Pretpostavke :
 ;  String koji se pretrazuje je ogranicen na 255 znakova.
 ;  Ako se string cita iz fajla uzima se samo prvih 255 znakova
 ;   ili sve do kraja prvog reda (manje od ta dva)
 ;________________________________________________________________
     	mov CX,255		; CX = br. bajtova koji se cita
     	mov DX,offset string	; DS:DX = bafer u koji se smesta ucitano
     	mov AH,3Fh		; funkcija 3Fh je za CITANJE iz fajla
     	int 21h
     	jnc Cit1OK 		; nije bilo greske pri citanju iz fajla
     	call grcit		; greska pri citanju - obavestava se korisnik
     	jmp close1		; i ide na zatvaranje fajla
 Cit1OK:cmp AL,0		; po citanju u AX je broj procitanih bajtova
     	jne skrati		; ako je razlicito od nule skrati procitano do kraja reda,
     				; a ako je nula (prazan fajl)
	mov DX,offset strfajlprazan
     	mov AH,9		; obavestava se korisnik
     	int 21h     				
 close1:mov AH,3Eh		; 
     	int 21h			; ZATVARA se fajl
     	
     	jmp unosSF		; i zahteva novi fajl sa stringom
     	
 skrati:mov stringduz,AL	; u AL se nalazi broj procitanih bajtova
     	
     	mov CX,AX		; cl=broj procitanih bajtova
     	mov AL,13		; al = 13 = <CR>
     	mov DI,DX		; DX vec ukazuje na pocetak stringa
     	cld			; autoincrement
  	repne scasb		; trazi <CR> u procitanom baferu
  	jne zatv		; ako nije nadjen <CR>, ceo bafer predstavlja string
  	dec DI			; a, ako je nadjen
  	sub DI, DX		; (DI - offset string) predstavlja broj znakova u stringu
  	jnz strOK		; ako je to razlicito od nule onda je OK
  	mov AH,3Eh		; a ako je nula (prvi red fajla je prazan)
  	int 21h			; fajl se zatvara
  	lea DX,prviredprazan	; obavestava se korisnik o gresci
  	mov AH,9
  	int 21h
  	jmp unosSF		; i trazi novi fajl sa stringom
 strOK: mov AX,DI
  	mov stringduz,AL	; i to se snima u promenljivu stringduz
     	
 zatv: 	mov AH,3Eh		; funkcija 3Eh je za ZATVARANJE fajla
     	int 21h
;-----------------------------------------------------------------
; Unos imena fajla za pretrazivanje
;_________________________________________________________________
 unosF: mov DX,offset unosfajla	; ispis poruke
	mov AH,9		; "Unesi fajla za pretrazivanje"
	int 21h     	
     	
     	mov DX,offset fajlmaxduz; unos imena fajla
	mov AH,0Ah		; 
	int 21h			;
     
     	xor BH,BH		; bh=0
     	mov BL,fajlduz		; bl=br.procitanih karaktera
     	cmp BL,0
     	je  unosF		; ako nije nista uneseno ponavlja se citanje
	mov byte ptr imefajla[BX],0	; poslednji karakter imena fajla mora biti 0
     	
     	mov DX,offset imefajla	; ime fajla za otvaranje
     	mov AX,3D00h		; otvaranje fajla
     	int 21h	
     	jnc fajlOK		; nije bilo greske pri otvaranju
     	call grotv		; greska pri otvaranju - obavestava se korisnik
     	jmp unosF		; i trazi novi fajl		

 fajlOK:mov BX,AX		; file handle
     	
 csupit:mov DX,offset caseupit	; "da li se razlikuju velika i mala slova"
     	mov AH,9
     	int 21h
     	
	mov AH,1		; funkcija broj 1
     	int 21h			; dos interapta 21h sluzi za unos 1 karaktera u AL
     	
     	cmp AL,"n"		; mala i velika slova se ne razlikuju
     	je  csins
     	cmp AL,"N"		; mala i velika slova se ne razlikuju
     	je  csins
     	cmp AL,13		; <enter> =
     	je  csins		; podrazumevano:mala i velika slova se ne razlikuju     	
     	cmp AL,"r"		; mala i velika slova se razlikuju
     	je  cssens
     	cmp AL,"R"		; mala i velika slova se razlikuju
     	je  cssens
     	jmp csupit		; ako je pritisnuto nedozvoljeno dugme vraca se na case upit
     	
 cssens:mov casesens,1
 	jmp count
 csins:	mov casesens,0 	    	
     	
 count:	call SEEK		; procedura koja broji ponavljanja u BP
	     	
     	mov AH,3Eh		; zatvaranje fajla
     	int 21h
     	
     	mov DX,offset brojpojav	; ipis poruke
     	mov AH,9		; "Broj ponavljanja je"
     	int 21h
     	
     	call PisiBP		; procedura koja ispisuje decimaljnu vrednost BP
     	     	
 KRAJ:	mov AX,4C00h		; funkcija 4Ch interapta 21h sluzi za
	int 21h			; izlaz u DOS sa izlaznim kodom u AL (0)

 KOD    ENDS			; kraj KOD segmenta

;-----------------------------------------------------------------
; Stek segment poravnat na paragraf
;_________________________________________________________________
 STEK 	segment para stack 'stack'
		db	100 dup (?)
 STEK 	ENDS
 
 END 	START			; kraj fajla i oznaka pocetne labele izvrsnog dela programa
